<template>
  <section class="content">
    <div id="overlay"  v-if="loading">
    <div class="spinner"></div>
    <br/>
      <h4>Loading...</h4>
    </div>
      <div class="box box-info">
        <!-- <Toast style="margin-top: 35px" /> -->
        <form class="form-horizontal">
          <div class="p-grid">
            <div class="p-col">
              <Button class="p-button-raised p-button-rounded" style="float: right" @click.prevent="openAddDialog" icon="pi pi-plus"/>
            </div>
          </div>
          <Dialog header="USER" :visible.sync="showDialog"
           :style="{width: '50vw'}" :modal="true" :closable="false" :contentStyle="{'overflow': 'visible'}">
           <div class="p-fluid p-formgrid p-grid">
             <div class="p-field p-col-12 p-md-6">
              <label for="accountHead" >Name</label>
                <InputText v-model.trim="name" id="accountHead"/>
            </div>
            <div class="p-field p-col-12 p-md-6" v-if="!this.editing">
              <label for="username">Username<span style="color:red">*</span></label>
              <InputText v-model.trim="userName" id="username"/>
            </div>
            <div class="p-field p-col-12 p-md-6" v-if="!this.editing">
              <label for="password" >Password<span style="color:red">*</span></label>
              <Password type="password" v-model.trim="password" toggleMask :feedback="false" id="password"/>
            </div>
            <a><i class="pi pi-eye" style="margin-top: 2em;" aria-hidden="true"  @click="showPass"></i></a>
              <div class="p-field p-col-12 p-md-6" v-if="!this.editing">
                <label for="rePassword" >Re-password<span style="color:red">*</span></label>
                <Password type="rePassword" v-model.trim="rePassword" toggleMask :feedback="false" id="rePassword"/>
            </div>
            <a><i class="pi pi-eye" style="margin-top: 2em;" aria-hidden="true"  @click="showConfirmPass"></i></a>
            <div class="p-field p-col-12 p-md-6">
              <label for="role">Role<span style="color:red">*</span></label>
              <Dropdown
                v-model="roleId" :filter=true
                :options="roleLists"
                id=role
                optionLabel="name"
                placeholder="Select Role"
                :showClear="true"
              />
             <!-- {{roleId}} -->


            </div>
            <div class="p-field p-col-12 p-md-6">
              <label for="openingBalance">Status</label>
                <div class="p-field p-col-12 p-md-6">
                  <RadioButton id="active" name="ACTIVE" value="ACTIVE" v-model="status" />
                  <label for="active">Active</label>
                  <RadioButton id="inactive" name="INACTIVE" value="INACTIVE" v-model="status" />
                  <label for="inactive">Inactive</label>
                </div>
              </div>
            
          </div>
           <template #footer>
            <Button class="p-button-raised p-button-rounded"
            @click.prevent="addUser"
             :label="!editing?'Add':'Update'"/>
             <Button class="p-button-raised p-button-rounded p-button-info"
            @click.prevent="addAndNewUser" v-if="!editing" label="Add & New"/>
            <Button label="Cancel" @click.prevent="cancel" class="p-button-raised p-button-rounded p-button-danger"/>
          </template>
          </Dialog>
        </form>
        <userList @delete-user="deleteUser"  @edit-user="updateUser"/>
      </div>
  </section>
</template>
<script>
import userList from './userList.vue'
import Dropdown from 'primevue/dropdown'
import Dialog from 'primevue/dialog'
import RadioButton from 'primevue/radiobutton'
import Button from 'primevue/button'
import InputText from 'primevue/inputtext'
import Password from 'primevue/password'
export default {
  name: 'userCreate',
  data() {
    return {
      name: '',
      roleId: '',
      warehouseId: null,
      counterId: null,
      userName: '',
      editing: false,
      password: '',
      rePassword: '',
      message: '',
      show: false,
      messageType: '',
      showDialog: false,
      loading: false,
      status: 'ACTIVE',
      userId: null
    }
  },
  computed: {
    roleLists() {
      return this.$store.state.users.roleLists
    },
    warehouseLists() {
      return this.$store.state.warehouse.warehouseLists
    },
    counterLists() {
      return this.$store.state.pos.countersList
    }
  },
  mounted() {
    this.roleList()
  },
  methods: {
    async addUser() {
      let response = ''
      if (this.name.trim() === '') {
        this.$toast.add({severity: 'error', summary: '', detail: 'Name cannot be empty!', life: 10000})
        return
      }
      if (!this.editing) {
        if (this.password !== this.rePassword) {
          this.$toast.add({severity: 'error', summary: '', detail: 'Password did not match!', life: 10000})
          return
        }
      }
      if (this.warehouseId === undefined || this.warehouseId === null) {
        this.warehouseId = null
      }
      if (this.roleId === undefined || this.roleId === null) {
        this.roleId = null
      }
      let user = {
        name: this.name,
        username: this.userName,
        role: this.roleId,
        password: this.password,
        status: this.status,
        userId: this.userId,
        warehouseId: this.warehouseId,
        counterId: this.counterId
      }
      if (!this.editing) {
        this.loading = !this.loading
        response = await this.$store.dispatch('createUser', user)
        this.loading = false
      } else {
        this.loading = !this.loading
        response = await this.$store.dispatch('updateUser', user)
        this.loading = false
      }
      this.responseMessage(response)
      this.showDialog = false
    },
    async addAndNewUser() {
      let response = ''
      if (this.name.trim() === '') {
        this.$toast.add({severity: 'error', summary: '', detail: 'Name cannot be empty!', life: 10000})
        return
      }
      if (!this.editing) {
        if (this.password.trim !== this.rePassword.trim) {
          this.$toast.add({severity: 'error', summary: '', detail: 'Password did not match!', life: 10000})
          return
        }
      }
      if (this.warehouseId === undefined || this.warehouseId === null) {
        this.warehouseId = null
      }
      if (this.roleId === undefined || this.roleId === null) {
        this.roleId = null
      }
      let user = {
        name: this.name,
        username: this.userName,
        role: this.roleId,
        password: this.password,
        status: this.status,
        userId: this.userId,
        warehouseId: this.warehouseId,
        counterId: this.counterId
      }
      this.loading = !this.loading
      response = await this.$store.dispatch('createUser', user)
      this.loading = false
      this.responseMessage(response)
    },
    responseMessage(response) {
      if (response.data.status === 'SUCCESS') {
        this.$toast.add({severity: 'success', summary: '', detail: response.data.message, life: 10000})
        this.cancel()
      } else if (response.data.status === 'ERROR') {
        this.$toast.add({severity: 'error', summary: '', detail: 'Something went wrong!', life: 10000})
      }
    },
    async roleList() {
      await this.$store.dispatch('loadRole')
    },
    deleteUser(data) {
      this.$toast.add({severity: data.messageType, summary: '', detail: data.message, life: 10000})
    },
    showPass() {
      var x = document.getElementById('password')
      if (x.type === 'password') {
        x.type = 'text'
      } else {
        x.type = 'password'
      }
    },
    showConfirmPass() {
      var x = document.getElementById('rePassword')
      if (x.type === 'password') {
        x.type = 'text'
      } else {
        x.type = 'password'
      }
    },
    updateUser(data) {
      // debugger
      this.name = data.name
      this.userName = data.username
      this.roleId = data.role
      this.editing = !this.editing
      this.showDialog = !this.showDialog
      this.status = data.status
      this.userId = data.id
      this.warehouseId = data.warehouseId
    },
    openAddDialog() {
      this.showDialog = !this.showDialog
    },
    cancel(data) {
      this.name = ''
      this.userName = ''
      this.roleId = ''
      this.password = ''
      this.rePassword = ''
      this.editing = false
      this.showDialog = false
      this.warehouseId = null
      this.counterId = null
    },
    resetResponse() {
      this.response = ''
      this.roleId = ''
    }
  },
  components: {
    userList,
    Dropdown,
    Dialog,
    RadioButton,
    InputText,
    Button,
    Password
    // Toast
  }
}
</script>
<style scoped src="@../../../static/css/dialogEntry.css">

</style>
